/***************************************************************************
 * 
 * Copyright (c) 2014 Baidu.com, Inc. All Rights Reserved
 * $Id$ 
 * 
 **************************************************************************/
 
 
 
/**
 * src/np1.js ~ 2014/04/19 14:06:11
 * @author leeight(liyubei@baidu.com)
 * @version $Revision$ 
 * @description 
 *  
 **/
var bunyan = require( 'bunyan' );
var proxy = require( './proxy' );

var config = {
    port: 8095,
    target: {
        host: 'localhost',
        port: 8080
    }
};

var log = bunyan.createLogger({ name: 'p1' });

function access_log( req, res ) {
    log.info({
        req: { method: req.method, url: req.url, headers: req.headers },
        res: { status: res.statusCode, headers: res.headers }
    });
}

function server_error( req, res, msg ) {
    log.error({
        req: { method: req.method, url: req.url, headers: req.headers },
        res: { msg: msg }
    });

    res.writeHead( 500, { 'Content-Type': 'text/plain' });
    res.end( msg );
}

function filter( e, upstreamReq, upstreamRes, proxyReq, proxyRes ) {
    if ( e ) {
        return server_error( upstreamReq, upstreamRes, e.toString() );
    }

    var chunks = [];
    proxyRes.on( 'data', function( data ){
        chunks.push( data );
    });
    proxyRes.on( 'end', function(){

        var body = Buffer.concat( chunks ).toString( 'utf-8' );
        var root = null;

        try {
            root = JSON.parse( body );
        }
        catch( ex ) {
            return server_error( upstreamReq, upstreamRes, ex.toString() );
        }

        if ( root.versions ) {
            for( var key in root.versions ) {
                var item = root.versions[ key ];
                var tarball = item.dist.tarball;

                item.dist.tarball = tarball.replace(
                    'http://registry.npmjs.org',
                    'http://npm.internal.baidu.com/-/shasum=' + item.dist.shasum );
            }
        }
        else if ( root.dist && root.dist.tarball ) {
            root.dist.tarball = root.dist.tarball.replace(
                'http://registry.npmjs.org',
                'http://npm.internal.baidu.com/-/shasum=' + root.dist.shasum );
        }

        body = JSON.stringify( root );

        access_log( upstreamReq, proxyRes );
        upstreamRes.writeHead( proxyRes.statusCode, proxyRes.headers );
        upstreamRes.end( body );
    });
}

proxy.createServer( config, filter );


















/* vim: set ts=4 sw=4 sts=4 tw=100: */
