/***************************************************************************
 * 
 * Copyright (c) 2014 Baidu.com, Inc. All Rights Reserved
 * $Id$ 
 * 
 **************************************************************************/
 
 
 
/**
 * src/p1.js ~ 2014/04/16 13:39:38
 * @author leeight(liyubei@baidu.com)
 * @version $Revision$ 
 * @description 
 * 把metadata中的tarball的地址修改掉
 * @see http://git.jumbo.ws/liyubei/edp-www/blob/edp/jpaas/edp.baidu.com/main.js
 **/
// :root -> versions -> dist -> tarball

var http = require( 'http' );
var proxy = require( 'http-proxy' ).createProxyServer({});

proxy.on('error', function (err, req, res) {
    res.writeHead(500, {
        'Content-Type': 'text/plain'
    });

    res.end('Something went wrong. And we are reporting a custom error message.');
});

var server = require('http').createServer(function(req, res) {
    req.headers.host = 'npm.internal.baidu.com';

    var end = res.end;
    var write = res.write;
    var writeHead = res.writeHead;

    var buffer = [];
    res.write = function( data ) {
        buffer.push( data );
    }
    res.end = function( data, encoding) {
        if ( data ) {
            buffer.push( data );
        }

        var body = Buffer.concat( buffer ).toString();
        if ( !body ) {
            res.write = write;
            end.call( res, Buffer.concat( buffer ), encoding );
            return;
        }

        var root = JSON.parse( body );
        if ( root.versions ) {
            for( var key in root.versions ) {
                var item = root.versions[ key ];
                var tarball = item.dist.tarball;

                item.dist.tarball = tarball.replace(
                    'http://registry.npmjs.org',
                    'http://npm.internal.baidu.com/-/shasum=' + item.dist.shasum );
            }
        }
        else if ( root.dist && root.dist.tarball ) {
            root.dist.tarball = root.dist.tarball.replace(
                'http://registry.npmjs.org',
                'http://npm.internal.baidu.com/-/shasum=' + root.dist.shasum );
        }

        body = JSON.stringify( root );

        res.write = write;
        end.call( res, new Buffer( body, encoding ), encoding );
    }

    res.writeHead = function( code, headers ) {
        res.removeHeader( 'Content-Length' );
        if ( headers ) {
            delete headers['content-length'];
        }
        writeHead.call( res, code, headers );
    }

    proxy.proxyRequest(req, res, { target: 'http://jx-vs-fe00.jx.baidu.com:8984' } );
});

server.listen( 8985 );


















/* vim: set ts=4 sw=4 sts=4 tw=100: */
