/***************************************************************************
 * 
 * Copyright (c) 2014 Baidu.com, Inc. All Rights Reserved
 * $Id$ 
 * 
 **************************************************************************/
 
 
 
/**
 * src/base.js ~ 2014/04/19 15:30:04
 * @author leeight(liyubei@baidu.com)
 * @version $Revision$ 
 * @description 
 *  
 **/
var http = require( 'http' );

/**
 * @param {Object} config 服务器相关的配置信息
 * @param {Function=} callback http response的处理函数.
 */
exports.createServer = function( config, callback ) {
    callback = callback || function( req, res, proxyReq, proxyRes ) {
        res.writeHead( proxyRes.statusCode, proxyRes.headers );
        proxyRes.pipe( res );
    };

    var proxy = http.createServer(function( req, res ){
        var reqBody = [];
        req.on( 'data', function( data ){
            reqBody.push( data );
        });
        req.on( 'end', function(){
            var method = req.method;
            var headers = req.headers;
            var path = req.url;

            reqBody = Buffer.concat( reqBody );
            headers[ 'connection' ] = 'close';
            if ( !headers[ 'content-length' ] ) {
                headers[ 'content-length' ] = reqBody.length;
            }

            var options = {
                host: config.target.host,
                port: config.target.port,
                method: method,
                path: path,
                headers: headers
            };

            var proxyReq = http.request( options, function( proxyRes ) {
                callback( null, req, res, proxyReq, proxyRes );
            });
            proxyReq.on( 'error', function( e ){
                callback( e, req, res, proxyReq, null );
            });
            proxyReq.write( reqBody );
            proxyReq.end();
        });
    });

    proxy.listen( config.port );

    return proxy;
};




















/* vim: set ts=4 sw=4 sts=4 tw=100: */
